//----------------------------------------------------------------
// bitmap.h
//----------------------------------------------------------------
// Copyright of John Wong 1998
//
// You are free to use this source code as long as it is for
// non-commercial use and this copyright notice is retained.
//----------------------------------------------------------------
// Revision History
//
// [JW-JUN.18.1998] v01.00  John Wong
//----------------------------------------------------------------

inline DWORD DWORDAlign(DWORD a_numBytes)
{
	return (((a_numBytes * 8 + 31) & (~31)) / 8);
}

HBITMAP LoadBitmapResource(
	HINSTANCE	a_hInst,
	LPCSTR		a_pszResource,
	HPALETTE	*a_phPalette);
HBITMAP LoadBitmapFile(
	LPCSTR		a_pszFile,
	HPALETTE	*a_phPalette);

class CDibSection
{
public:
	CDibSection();
	~CDibSection();

	BOOL Create(int a_lWidth, int a_lHeight, int a_lBitDepth);
	BOOL Load(LPCSTR a_pszPathName, HPALETTE *a_phPalette);
	BOOL Load(HINSTANCE a_hInst, LPCSTR a_pszResName, HPALETTE *a_phPalette);
	BOOL SetColorTable(const RGBQUAD* a_prgb);
	BOOL GetColorTable(RGBQUAD* a_prgb);
	BOOL Free();

	HDC			GetDC() {return m_hDC;}
	PBYTE		GetPointer() {return m_pData;}
	DWORD		GetLineWidth() {return m_dwLineWidth;}
	int			GetWidth() {return m_lWidth;}
	int			GetHeight() {return m_lHeight;}
	int			GetBitCount() {return m_lBitCount;}
protected:
	HBITMAP		m_hBitmap;
	HBITMAP		m_hOldBitmap;
	HDC			m_hDC;
	PBYTE		m_pData;
	DWORD		m_dwLineWidth;
	int			m_lWidth;
	int			m_lHeight;
	int			m_lBitCount;
};

	
